import sys

n = int(sys.stdin.readline())
nums = list(map(int, sys.stdin.readline().split()))

res = 100000
min_x = 1
min_y = 2
min_z = 3

for x in range(len(nums)-2):
    l, r = x+1, len(nums)-1
    x_sum, y_sum, z_sum = sum(nums[x:l]),sum(nums[l:r]),sum(nums[r:len(nums)])+sum(nums[0:x])
    print(x)
    while l < r:
        if x_sum > y_sum: #рухаємо лівий поінтер праворуч 
        #(збільшуємо хsum на l та зменш lsum на l)
            print('ліво')
            print(x_sum, y_sum, z_sum)
            x_sum += nums[l]
            y_sum -= nums[l]
            l += 1
        else: #рухаємо правий ліворуч 
        #(зменшуємо lsum на r, збільш zsum на r)
            print('право')
            print(x_sum, y_sum, z_sum)
            x_sum += nums[l]
            y_sum -= nums[l]
            r -= 1
        if max(x_sum, y_sum, z_sum) - min(x_sum, y_sum, z_sum) < res:
            res = max(x_sum, y_sum, z_sum) - min(x_sum, y_sum, z_sum)
            min_x, min_y, min_z = x, l, r

print(res)
print(min_x+1,min_y+1,min_z+1)